'Numser.bas     Ray Thomas      April 2002

OPTION BASE 1

DECLARE SUB Menu ()
DECLARE SUB Catalan ()
DECLARE SUB Facts ()
DECLARE SUB Fibon ()
DECLARE SUB Harmon ()
DECLARE SUB Mersenne ()
DECLARE SUB Pascal ()
DECLARE SUB Perfect ()
DECLARE SUB Primes ()
DECLARE SUB QSort (SortArray() AS LONG, Low AS INTEGER, High AS DOUBLE)
DECLARE SUB Square ()
DECLARE SUB Triang ()
DECLARE SUB Vampire ()
DECLARE SUB Continue ()

DIM SHARED UserIn AS STRING     'User input
DIM SHARED UserNum AS DOUBLE    'User number
DIM SHARED Count AS DOUBLE      'Loop counter
DIM SHARED OldNum AS DOUBLE     'Previous number generated

DO
        Menu

        Catalan

        Continue

        Facts

        Continue

        Fibon

        Continue

        IF UserIn = "C" AND UserNum < 4 THEN
                     
                Harmon

                Continue
        END IF
              
        Mersenne

        Continue

        Pascal
              
        Continue
               
        Perfect

        Continue

        Primes

        Continue

        Square

        Continue

        Triang

        Continue

        Vampire

        Continue

LOOP UNTIL UserIn$ = CHR$(27)

END

SUB Catalan

'*** Catalan series ***

DIM Cat AS DOUBLE
DIM Row AS DOUBLE
DIM RowFact AS DOUBLE
DIM Num AS DOUBLE
DIM NumFact AS DOUBLE
DIM NumRow AS DOUBLE
DIM InterMed AS DOUBLE

CLS
PRINT
PRINT "CATALAN NUMBERS"
PRINT
PRINT "Catalan numbers are a binomial series, BINOMIAL [2n, n]/(n + 1)"
PRINT

IF UserIn$ = "A" THEN   '*** First n of a series ***
      
        PRINT "These are the first"; UserNum; "Catalan numbers."
        PRINT
        PRINT 1;        '*** I can't calculate this ***

        Row = 0
        Num = 0

        FOR Count = 1 TO UserNum
     
                Num = Num + 1
                Row = Row + 2
                NumFact = 1
                RowFact = 1
                NumRow = 1

                '*** Calculate the factorials ***
               
                FOR Counter = 1 TO Num
                        NumFact = NumFact * Counter
                NEXT Counter
                FOR Counter = 1 TO Row
                        RowFact = RowFact * Counter
                NEXT Counter
                FOR Counter = 1 TO Row - Num
                        NumRow = NumRow * Counter
                NEXT Counter

                '*** Do the sums ***

                '*** Intermed is the series from Pascal's Triangle ***
                '*** 1, 2, 6, 20, 70 ... ***

                InterMed = RowFact / (NumFact * NumRow)

                Cat = InterMed / (Num + 1)
               
                PRINT Cat;

                IF CSRLIN > 19 THEN
                        Continue
                        CLS
                        PRINT
                END IF

        NEXT Count
END IF

IF UserIn$ = "B" THEN   '*** Series up to a number ***

        PRINT "These are the Catalan numbers up to"; UserNum
        PRINT
        PRINT 1;        '*** I can't calculate this ***

        Row = 0
        Num = 0
        Count = 1

        DO
                Num = Num + 1
                Row = Row + 2
                NumFact = 1
                RowFact = 1
                NumRow = 1

                '*** Calculate the factorials ***
              
                FOR Counter = 1 TO Num
                        NumFact = NumFact * Counter
                NEXT Counter
                FOR Counter = 1 TO Row
                        RowFact = RowFact * Counter
                NEXT Counter
                FOR Counter = 1 TO Row - Num
                        NumRow = NumRow * Counter
                NEXT Counter

                '*** Do the sums ***

                '*** Intermed is the series from Pascal's Triangle ***
                '*** 1, 2, 6, 20, 70 ... ***

                InterMed = RowFact / (NumFact * NumRow)

                Cat = InterMed / (Num + 1)
              
                PRINT Cat;
                Count = Count + 1

                IF CSRLIN > 19 THEN
                        Continue
                        CLS
                        PRINT
                END IF

        LOOP UNTIL Cat >= UserNum
       
        PRINT
        PRINT
        PRINT "There are"; Count; "Catalan numbers less than or equal to"; UserNum
END IF

IF UserIn$ = "C" THEN   '*** Number in a series? ***

        Row = 0
        Num = 0
        Count = 1

        DO
                Num = Num + 1
                Row = Row + 2
                NumFact = 1
                RowFact = 1
                NumRow = 1
                OldNum = Cat

                '*** Calculate the factorials ***
             
                FOR Counter = 1 TO Num
                        NumFact = NumFact * Counter
                NEXT Counter
                FOR Counter = 1 TO Row
                        RowFact = RowFact * Counter
                NEXT Counter
                FOR Counter = 1 TO Row - Num
                        NumRow = NumRow * Counter
                NEXT Counter

                '*** Do the sums ***

                '*** Intermed is the series from Pascal's Triangle ***
                '*** 1, 2, 6, 20, 70 ... ***

                InterMed = RowFact / (NumFact * NumRow)

                Cat = InterMed / (Num + 1)
           
                Count = Count + 1

        LOOP UNTIL Cat >= UserNum
     
        IF Cat = UserNum THEN
                PRINT UserNum; "is a Catalan number"
                PRINT
                PRINT "It is"; Count; "in the series"
        ELSE
                PRINT UserNum; "is not a Catalan number"
                PRINT
                PRINT "The next smallest number is"; OldNum; "the next Catalan number is"; Cat
        END IF
END IF

END SUB

SUB Continue

'*** Press any key to continue ***

PRINT
PRINT
PRINT "Press any key to continue ..."
DO
        LOOP UNTIL INKEY$ <> ""
PRINT

END SUB

SUB Facts

'*** Factorials ***

DIM Fact AS DOUBLE
DIM NewMax AS DOUBLE

NewMax = UserNum
IF UserNum > 169 THEN NewMax = 169

CLS
PRINT
PRINT "FACTORIAL NUMBERS"
PRINT
PRINT "Factorial numbers are the product of the numbers 1 to n"
PRINT
PRINT "These numbers get very big very quckly"
PRINT

IF UserIn$ = "A" THEN   '*** First n of a series ***
       
        PRINT "These are the first"; NewMax; "factorial numbers."
        PRINT

        Fact = 1

        FOR Count = 0 TO NewMax
       
                Fact = Fact + (Fact * Count)
                PRINT Fact;

                IF CSRLIN > 19 THEN
                        Continue
                        CLS
                        PRINT
                END IF

        NEXT Count
END IF

IF UserIn$ = "B" THEN   '*** Series up to a number ***

        PRINT "These are factorial numbers up to"; UserNum
        PRINT

        Fact = 1
        Count = 0

        DO
                Fact = Fact + (Fact * Count)
                IF Fact > UserNum THEN EXIT DO
                PRINT Fact;
                Count = Count + 1

                IF CSRLIN > 19 THEN
                        Continue
                        CLS
                        PRINT
                END IF

        LOOP UNTIL Fact >= UserNum

        PRINT
        PRINT
        PRINT "There are"; Count; "factorials under or equal to"; UserNum
END IF

IF UserIn$ = "C" THEN   '*** Number in a series? ***

        Fact = 1
        Count = 0

        DO
                OldNum = Fact
                Fact = Fact + (Fact * Count)
                Count = Count + 1

        LOOP UNTIL Fact >= UserNum

        IF Fact = UserNum THEN
                PRINT UserNum; "is a Factorial"
                PRINT
                PRINT "It is"; Count; "in the series"
        ELSE
                PRINT UserNum; "is not a factorial"
                PRINT
                PRINT "The next smallest number is"; OldNum; "the next factorial is"; Fact
        END IF
END IF

END SUB

SUB Fibon

'*** Fibonacci numbers ***

DIM Num AS DOUBLE
DIM SumNum AS DOUBLE
DIM NewNum AS DOUBLE

CLS
PRINT
PRINT "FIBONACCI NUMBERS"
PRINT
PRINT "Fibonacci numbers are the series of numbers where the next number generated"
PRINT "is the sum of the previous two numbers."
PRINT
PRINT "These numbers get very big very quckly"
PRINT

IF UserIn$ = "A" THEN   '*** First n of the series ***

        PRINT "The first"; UserNum; "numbers in the Fibonacci series are :-"
        PRINT

        SumNum = 0
        OldNum = 0
        NewNum = 1
        Count = 0

        DO
                PRINT SumNum;
                SumNum = OldNum + NewNum
                NewNum = OldNum
                OldNum = SumNum
                Count = Count + 1
       
                IF CSRLIN > 19 THEN
                        Continue
                        CLS
                        PRINT
                END IF

        LOOP UNTIL Count = UserNum
END IF

IF UserIn$ = "B" THEN   '*** Series up to a number ***

        PRINT "The Fibonacci series up to and including"; UserNum; "are :-"
        PRINT

        SumNum = 0
        OldNum = 0
        NewNum = 1
        Count = 0

        DO
                PRINT SumNum;
                SumNum = OldNum + NewNum
                NewNum = OldNum
                OldNum = SumNum
                Count = Count + 1
      
                IF CSRLIN > 19 THEN
                        Continue
                        CLS
                        PRINT
                END IF

        LOOP UNTIL SumNum >= UserNum

        PRINT
        PRINT
        PRINT "There are"; Count; "Fibonacci numbers under or equal to"; UserNum
END IF

IF UserIn$ = "C" THEN   '*** Number in a series? ***

        SumNum = 0
        OldNum = 0
        NewNum = 1
        Count = 0

        DO
                OldNum = SumNum
                SumNum = OldNum + NewNum
                NewNum = OldNum
                Count = Count + 1
     
                IF CSRLIN > 19 THEN
                        Continue
                        CLS
                        PRINT
                END IF

        LOOP UNTIL SumNum >= UserNum

        IF SumNum = UserNum THEN
               
                PRINT UserNum; "is a Fibonacci number"
                PRINT
                PRINT "It is"; Count + 1; "in the series"
        ELSE
                PRINT UserNum; "is not a Fibonacci number"
                PRINT
                PRINT "The next smallest number is"; OldNum; "the next Fabonacci number is"; SumNum
        END IF
END IF

END SUB

SUB Harmon

DIM HarmDen AS DOUBLE   'Harmonic denominator
DIM HarmNum AS DOUBLE   'Harmonic numerator
DIM HarmSum AS DOUBLE   'The sum of the series, as a decimal
DIM NewDen AS DOUBLE    'Next denominator
DIM NewNum AS DOUBLE    'Next numerator to be added
DIM CmnDen AS DOUBLE    'Common denominator
DIM WholeNum AS INTEGER 'Integer part of numerator / denominator
DIM Counter AS LONG     'Loop counter
DIM OldDen AS DOUBLE    'Old denominator
DIM Harm AS DOUBLE      'Result of numerator / denominator

CLS
PRINT
PRINT "HARMONIC NUMBERS"
PRINT
PRINT "Harmonic numbers are the series 1 + 1/2 + 1/3 + 1/4 +  1/5 etc. to 1/n"
PRINT

IF UserIn$ = "A" THEN   '*** First n of a series ***
      
        PRINT "These are the first"; UserNum; "Harmonic numbers."
        PRINT
        PRINT 1

        HarmDen = 1
        HarmNum = 1
        NewDen = 1
        CmnDen = 0

        FOR Count = 2 TO UserNum
     
                NewDen = NewDen + 1
                CmnDen = HarmDen * NewDen
                HarmNum = HarmNum * NewDen
                NewNum = HarmDen
                HarmNum = HarmNum + NewNum
                HarmDen = CmnDen
                PRINT STR$(HarmNum); "/"; LTRIM$(STR$(HarmDen));

               
                '*** To improve the speed of the program REM (or use ') ***
                '*** From the line below to the line '*********************

                '*** Factorise the Harmonic fraction ***
             
                FOR Counter = HarmDen TO 2 STEP -1
                        IF HarmNum MOD Counter = 0 AND HarmDen MOD Counter = 0 THEN
                                HarmNum = HarmNum / Counter
                                HarmDen = HarmDen / Counter
                                PRINT " = "; LTRIM$(STR$(HarmNum)); "/"; LTRIM$(STR$(HarmDen));
                        END IF
                        IF HarmNum MOD 2 = 0 AND HarmDen MOD 2 = 0 THEN
                                HarmNum = HarmNum / 2
                                HarmDen = HarmDen / 2
                                PRINT " = "; LTRIM$(STR$(HarmNum)); "/"; LTRIM$(STR$(HarmDen));
                        END IF
                NEXT Counter

                '*** Produce a mixed number ***

                WholeNum = INT(HarmNum / HarmDen)
                PRINT " ="; WholeNum; LTRIM$(STR$(HarmNum MOD HarmDen)); "/"; LTRIM$(STR$(HarmDen));

                '**********************************************************

                PRINT " ="; HarmNum / HarmDen
       
                IF CSRLIN > 19 THEN
                        Continue
                        CLS
                        PRINT
                END IF
       
        NEXT Count
END IF

IF UserIn$ = "B" THEN   '*** Harmonic series up to and including a number ***
    
        PRINT "These are Harmonic numbers up to"; UserNum
        PRINT
        PRINT 1

        HarmDen = 1
        HarmNum = 1
        NewDen = 1
        CmnDen = 0
        Count = 0

        DO
                NewDen = NewDen + 1
                CmnDen = HarmDen * NewDen
                HarmNum = HarmNum * NewDen
                NewNum = HarmDen
                HarmNum = HarmNum + NewNum
                HarmDen = CmnDen
                Count = Count + 1
                IF HarmNum / HarmDen > UserNum THEN EXIT DO
                PRINT STR$(HarmNum); "/"; LTRIM$(STR$(HarmDen));

                '*** To improve the speed of the program REM (or use ') ***
                '*** From the line below to the line '*********************
            
                '*** Factorise the Harmonic fraction ***
            
                FOR Counter = HarmDen TO 2 STEP -1
                        IF HarmNum MOD Counter = 0 AND HarmDen MOD Counter = 0 THEN
                                HarmNum = HarmNum / Counter
                                HarmDen = HarmDen / Counter
                                PRINT " = "; LTRIM$(STR$(HarmNum)); "/"; LTRIM$(STR$(HarmDen));
                        END IF
                        IF HarmNum MOD 2 = 0 AND HarmDen MOD 2 = 0 THEN
                                HarmNum = HarmNum / 2
                                HarmDen = HarmDen / 2
                                PRINT " = "; LTRIM$(STR$(HarmNum)); "/"; LTRIM$(STR$(HarmDen));
                        END IF
                NEXT Counter

                '*** Produce a mixed number ***

                WholeNum = INT(HarmNum / HarmDen)
                PRINT " ="; WholeNum; LTRIM$(STR$(HarmNum MOD HarmDen)); "/"; LTRIM$(STR$(HarmDen));

                '**********************************************************
              
                PRINT " ="; HarmNum / HarmDen
      
                IF CSRLIN > 19 THEN
                        Continue
                        CLS
                        PRINT
                END IF
     
        LOOP UNTIL HarmNum / HarmDen >= UserNum
       
        PRINT
        PRINT "There are"; Count; "Harmonic numbers smaller or equal to"; UserNum
END IF

IF UserIn$ = "C" THEN   '*** Number in the Harmonic series? ***
   
        HarmDen = 1
        HarmNum = 1
        NewDen = 1
        CmnDen = 0
        Count = 1
        OldNum = 0
        OldDen = 0

        DO
                OldNum = HarmNum
                OldDen = HarmDen
                NewDen = NewDen + 1
                CmnDen = HarmDen * NewDen
                HarmNum = HarmNum * NewDen
                NewNum = HarmDen
                HarmNum = HarmNum + NewNum
                HarmDen = CmnDen
                Count = Count + 1
                Harm = HarmNum / HarmDen

        LOOP UNTIL Harm >= UserNum
              
        '*** To improve the speed of the program REM (or use ') ***
        '*** From the line below to the line '*********************

        IF Harm = UserNum THEN
                PRINT UserNum; "is a Harmonic Number"
                PRINT
                PRINT "It is"; Count; "in the series"
                PRINT
                PRINT STR$(HarmNum); "/"; LTRIM$(STR$(HarmDen));
        ELSE
                PRINT UserNum; "is not a Harmonic number."
                PRINT
                PRINT "The next smallest number is"; STR$(OldNum); "/"; LTRIM$(STR$(OldDen));
                SWAP OldNum, HarmNum
                SWAP OldDen, HarmDen
        END IF
           
        '*** To improve the speed of the program REM (or use ') ***
        '*** From the line below to the line '*********************
       
        '*** Factorise the Harmonic fraction ***
       
        FOR Counter = HarmDen TO 2 STEP -1
                IF HarmNum MOD Counter = 0 AND HarmDen MOD Counter = 0 THEN
                        HarmNum = HarmNum / Counter
                        HarmDen = HarmDen / Counter
                        PRINT " = "; LTRIM$(STR$(HarmNum)); "/"; LTRIM$(STR$(HarmDen));
                END IF
                IF HarmNum MOD 2 = 0 AND HarmDen MOD 2 = 0 THEN
                        HarmNum = HarmNum / 2
                        HarmDen = HarmDen / 2
                        PRINT " = "; LTRIM$(STR$(HarmNum)); "/"; LTRIM$(STR$(HarmDen));
                END IF
        NEXT Counter

        '*** Produce a mixed number ***

        WholeNum = INT(HarmNum / HarmDen)
        PRINT " ="; WholeNum; LTRIM$(STR$(HarmNum MOD HarmDen)); "/"; LTRIM$(STR$(HarmDen));
               
        '**********************************************************

        PRINT " ="; HarmNum / HarmDen

        IF Harm > UserNum THEN

                SWAP OldNum, HarmNum
                SWAP OldDen, HarmDen
               
                PRINT
                PRINT "The next largest is"; STR$(HarmNum); "/"; LTRIM$(STR$(HarmDen));
              
                '*** To improve the speed of the program REM (or use ') ***
                '*** From the line below to the line '*********************
      
                '*** Factorise the Harmonic fraction ***
           
                FOR Counter = HarmDen TO 2 STEP -1
                        IF HarmNum MOD Counter = 0 AND HarmDen MOD Counter = 0 THEN
                                HarmNum = HarmNum / Counter
                                HarmDen = HarmDen / Counter
                                PRINT " = "; LTRIM$(STR$(HarmNum)); "/"; LTRIM$(STR$(HarmDen));
                        END IF
                        IF HarmNum MOD 2 = 0 AND HarmDen MOD 2 = 0 THEN
                                HarmNum = HarmNum / 2
                                HarmDen = HarmDen / 2
                                PRINT " = "; LTRIM$(STR$(HarmNum)); "/"; LTRIM$(STR$(HarmDen));
                        END IF
                NEXT Counter
               
                '*** Produce a mixed number ***

                WholeNum = INT(HarmNum / HarmDen)
                PRINT " ="; WholeNum; LTRIM$(STR$(HarmNum MOD HarmDen)); "/"; LTRIM$(STR$(HarmDen));

                '********************************************************

                PRINT " ="; HarmNum / HarmDen
        END IF
END IF

END SUB

SUB Menu

'*** Introduction and menu to the program ***

CLS
PRINT
PRINT "     This program is an introduction to number series."
PRINT
PRINT "     The series this program can calculate are :-"
PRINT
PRINT "     Factorials, Fibonacci, Mersenne Primes, Pascal, Perfect, Primes,"
PRINT "     Squares, Triangular and Vampire."
PRINT
PRINT
PRINT
PRINT "     Choose what you want the program to do :-"
PRINT
PRINT
PRINT "          A = The first n numbers of the series."
PRINT
PRINT "          B = The series up to and including your number."
PRINT
PRINT "          C = Test if your number is part of the series."
PRINT
PRINT "          Esc = Exit Program"
PRINT
DO
        UserIn$ = UCASE$(INKEY$)

LOOP UNTIL INSTR(" ABC", UserIn$) > 1 OR UserIn$ = CHR$(27)

IF UserIn$ = CHR$(27) THEN END

PRINT
PRINT
PRINT "     There are limits to the size of the numbers that can be displayed :-"
PRINT
PRINT "     First 169 only in the Factorial series, first 8 only in Mersenne Primes"
PRINT "     and Perfect numbers, 6 digit Vampire numbers etc."
PRINT
INPUT ; "          What is your number"; UserNum
PRINT

END SUB

SUB Mersenne

'*** Mersenne Prime Numbers ***

DIM TestNum AS DOUBLE           'TestNum the number being tested
DIM Prime AS INTEGER            'Switch to indicate a prime during testing
DIM Divisor AS LONG             'Holds divisors
DIM MersTest AS DOUBLE          'Mersenne test numbers
DIM MersDiv AS DOUBLE             'Holds Mersenne divisors
DIM MersPrime AS INTEGER        'Switch to indicate a Mersenne Prime

Divisor = 2
Count = 2

CLS

PRINT
PRINT "MERSENNE PRIME NUMBERS"
PRINT
PRINT "Mersenne Prime numbers are those that take the form (2^p) - 1"
PRINT
PRINT "Where p and the Mersenne number produced are prime numbers"
PRINT

IF UserIn$ = "A" THEN   '*** First n of the series ***
      
        PRINT "Here are the first"; UserNum; "Mersenne Prime numbers."
        PRINT

        PRINT 3; 7;     '*** I can't find a way of calculating these ***

        TestNum = 3
        Count = 2

        DO
                '*** First of all find the Prime Numbers ***
               
                Prime = 0
                Divisor = 3
                TestNum = TestNum + 2
   
                DO
                        IF TestNum MOD Divisor = 0 THEN Prime = 1
                        Divisor = Divisor + 2
                        IF Divisor > SQR(TestNum) THEN EXIT DO

                LOOP UNTIL Prime = 1
               
                '*** Now we've got a Prime, calculate the Mersenne Prime ***
               
                IF Prime = 0 THEN
                       
                        MersTest = (2 ^ TestNum) - 1

                        '*** Now test if MersTest is a Prime ***

                        MersPrime = 0
                        MersDiv = 3

                        DO
                                IF MersTest > 2147483647 THEN
                                       
                                        PRINT
                                        PRINT
                                        PRINT "Routine aborted, MOD can't cope with big numbers !!!"
                                        MersPrime = 1
                                        Count = UserNum
                                        EXIT DO
                                END IF

                                IF MersTest MOD MersDiv = 0 THEN MersPrime = 1
                                MersDiv = MersDiv + 2
                                IF MersDiv > SQR(MersTest) THEN EXIT DO

                        LOOP UNTIL MersPrime = 1

                        IF MersPrime = 0 THEN
                       
                                Count = Count + 1
                                PRINT MersTest;
                        END IF
                END IF

                IF CSRLIN > 19 THEN
                        Continue
                        CLS
                        PRINT
                END IF

        LOOP UNTIL Count = UserNum
END IF

IF UserIn$ = "B" THEN   '*** Mersenne Prime numbers up to and including a number ***
     
        PRINT "Here are the Mersenne Prime numbers up to or equal to"; UserNum
        PRINT

        PRINT 3; 7;     '*** I can't find a way of calculating these ***

        TestNum = 3
        Count = 2

        DO
                '*** First of all find the Prime Numbers ***
              
                Prime = 0
                Divisor = 3
                TestNum = TestNum + 2
  
                DO
                        IF TestNum MOD Divisor = 0 THEN Prime = 1
                        Divisor = Divisor + 2
                        IF Divisor > SQR(TestNum) THEN EXIT DO

                LOOP UNTIL Prime = 1
              
                '*** Now we've got a Prime, calculate the Mersenne Prime ***
              
                IF Prime = 0 THEN
                      
                        MersTest = (2 ^ TestNum) - 1

                        '*** Now test if MersTest is a Prime ***

                        MersPrime = 0
                        MersDiv = 3

                        DO
                                IF MersTest > 2147483647 THEN
                                      
                                        PRINT
                                        PRINT
                                        PRINT "Routine aborted, MOD can't cope with big numbers !!!"
                                        MersPrime = 1
                                        Count = UserNum
                                        EXIT DO
                                END IF

                                IF MersTest > UserNum THEN
                                        MersPrime = 1
                                        EXIT DO
                                END IF

                                IF MersTest MOD MersDiv = 0 THEN MersPrime = 1
                                MersDiv = MersDiv + 2
                                IF MersDiv > SQR(MersTest) THEN EXIT DO

                        LOOP UNTIL MersPrime = 1

                        IF MersPrime = 0 THEN
                      
                                Count = Count + 1
                                PRINT MersTest;
                        END IF
                END IF

                IF CSRLIN > 19 THEN
                        Continue
                        CLS
                        PRINT
                END IF


        LOOP UNTIL MersTest >= UserNum

        PRINT
        PRINT
        PRINT "There are"; Count; "Mersenne Prime numbers smaller or equal to"; UserNum
END IF

IF UserIn$ = "C" THEN   '*** Number is part of the series? ***
    
        TestNum = 3
        Count = 2

        DO
                '*** First of all find the Prime Numbers ***
              
                Prime = 0
                Divisor = 3
                TestNum = TestNum + 2
  
                DO
                        IF TestNum MOD Divisor = 0 THEN Prime = 1
                        Divisor = Divisor + 2
                        IF Divisor > SQR(TestNum) THEN EXIT DO

                LOOP UNTIL Prime = 1
              
                '*** Now we've got a Prime, calculate the Mersenne Prime ***
              
                IF Prime = 0 THEN
                      
                        MersTest = (2 ^ TestNum) - 1

                        '*** Now test if MersTest is a Prime ***

                        MersPrime = 0
                        MersDiv = 3

                        DO
                                IF MersTest > 2147483647 THEN
                                      
                                        PRINT
                                        PRINT
                                        PRINT "Routine aborted, MOD can't cope with big numbers !!!"
                                        MersPrime = 1
                                        Count = UserNum
                                        EXIT DO
                                END IF

                                IF MersTest MOD MersDiv = 0 THEN MersPrime = 1
                                MersDiv = MersDiv + 2
                                IF MersDiv > SQR(MersTest) THEN EXIT DO

                        LOOP UNTIL MersPrime = 1

                        IF MersPrime = 0 THEN
                                Count = Count + 1
                                IF MersTest >= UserNum THEN EXIT DO
                                IF MersTest < UserNum THEN OldNum = MersTest
                        END IF
                       
                END IF

        LOOP UNTIL MersPrime = 0 AND MersTest >= UserNum

        IF MersTest = UserNum THEN
             
                PRINT UserNum; "is a Mersenne Prime number"
                PRINT
                PRINT "It is"; Count; "in the series"
        ELSE
                PRINT UserNum; "is not a Mersenne Prime number"
                PRINT
                PRINT "The next smallest number is"; OldNum; "the next Mersenne Prime number is"; MersTest
        END IF
END IF


END SUB

SUB Pascal

'*** Pascal Numbers ***

DIM PascNum AS DOUBLE

CLS
PRINT
PRINT "PASCAL NUMBERS"
PRINT
PRINT "Pascal numbers are the sum of the numbers in each row of Pascal's Triangle"
PRINT

IF UserIn$ = "A" THEN   '*** First n of a series ***
      
        PRINT "These are the first"; UserNum; "Pascal numbers."
        PRINT

        FOR Count = 0 TO UserNum - 1
      
                PascNum = 2 ^ Count
                PRINT PascNum;

                IF CSRLIN > 19 THEN
                        Continue
                        CLS
                        PRINT
                END IF

        NEXT Count
END IF

IF UserIn$ = "B" THEN   '*** Series up to a number ***

        PRINT "These are Pascal numbers up to"; UserNum
        PRINT

        PascNum = 0
        Count = 0

        DO
                PascNum = 2 ^ Count
                IF PascNum > UserNum THEN EXIT DO
                PRINT PascNum;
                Count = Count + 1

                IF CSRLIN > 19 THEN
                        Continue
                        CLS
                        PRINT
                END IF

        LOOP UNTIL Fact >= UserNum

        PRINT
        PRINT
        PRINT "There are"; Count; "Pascal less than or equal to"; UserNum
END IF

IF UserIn$ = "C" THEN   '*** Number in a series? ***

        PascNum = 0
        Count = 0

        DO
                OldNum = PascNum
                PascNum = 2 ^ Count
                Count = Count + 1

        LOOP UNTIL PascNum >= UserNum

        IF Fact = UserNum THEN
                PRINT UserNum; "is a Pascal number"
                PRINT
                PRINT "It is"; Count; "in the series"
        ELSE
                PRINT UserNum; "is not a Pascal number"
                PRINT
                PRINT "The next smallest number is"; OldNum; "the next Pascal number is"; PascNum
        END IF
END IF

END SUB

SUB Perfect

'*** Perfect Numbers ***

DIM TestNum AS DOUBLE           'TestNum the number being tested
DIM Prime AS INTEGER            'Switch to indicate a prime during testing
DIM Divisor AS LONG             'Holds divisors
DIM MersTest AS DOUBLE          'Mersenne test numbers
DIM MersDiv AS DOUBLE           'Holds Mersenne divisors
DIM MersPrime AS INTEGER        'Switch to indicate a Mersenne Prime
DIM Perf AS DOUBLE              'Perfect Numbers

Divisor = 2
Count = 2

CLS

PRINT
PRINT "PERFECT NUMBERS"
PRINT
PRINT "Perfect numbers are those whose positive divisors (except for"
PRINT "itself) sum to itself. It is also a function of Mersenne Primes"
PRINT "using (2^m-1)((2^m)-1)"
PRINT

IF UserIn$ = "A" THEN   '*** First n of the series ***
     
        PRINT "Here are the first"; UserNum; "Perfect numbers."
        PRINT

        PRINT 6; 28;     '*** I can't find a way of calculating these ***

        TestNum = 3
        Count = 2

        DO
                '*** First of all find the Prime Numbers ***
              
                Perf = 0
                Prime = 0
                Divisor = 3
                TestNum = TestNum + 2
  
                DO
                        IF TestNum MOD Divisor = 0 THEN Prime = 1
                        Divisor = Divisor + 2
                        IF Divisor > SQR(TestNum) THEN EXIT DO

                LOOP UNTIL Prime = 1
              
                '*** Now we've got a Prime, calculate the Mersenne Prime ***
              
                IF Prime = 0 THEN
                      
                        MersTest = (2 ^ TestNum) - 1

                        '*** Now test if MersTest is a Prime ***

                        MersPrime = 0
                        MersDiv = 3

                        DO
                                IF MersTest > 2147483647 THEN
                                      
                                        PRINT
                                        PRINT
                                        PRINT "Routine aborted, MOD can't cope with big numbers !!!"
                                        MersPrime = 1
                                        Count = UserNum
                                        EXIT DO
                                END IF

                                IF MersTest MOD MersDiv = 0 THEN MersPrime = 1
                                MersDiv = MersDiv + 2
                                IF MersDiv > SQR(MersTest) THEN EXIT DO

                        LOOP UNTIL MersPrime = 1

                        '*** Now calculate the Perfect number ***
                       
                        IF MersPrime = 0 THEN
                      
                                Count = Count + 1
                                Perf = (2 ^ (TestNum - 1)) * MersTest
                                PRINT Perf;
                        END IF
                END IF

                IF CSRLIN > 19 THEN
                        Continue
                        CLS
                        PRINT
                END IF

        LOOP UNTIL Count = UserNum
END IF

IF UserIn$ = "B" THEN   '*** Perfect numbers up to and including a number ***
    
        PRINT "Here are the Perfect numbers up to or equal to"; UserNum
        PRINT

        PRINT 6; 28;     '*** I can't find a way of calculating these ***

        TestNum = 3
        Count = 2

        DO
                '*** First of all find the Prime Numbers ***
             
                Prime = 0
                Perf = 0
                Divisor = 3
                TestNum = TestNum + 2
 
                DO
                        IF TestNum MOD Divisor = 0 THEN Prime = 1
                        Divisor = Divisor + 2
                        IF Divisor > SQR(TestNum) THEN EXIT DO

                LOOP UNTIL Prime = 1
             
                '*** Now we've got a Prime, calculate the Mersenne Prime ***
             
                IF Prime = 0 THEN
                     
                        MersTest = (2 ^ TestNum) - 1

                        '*** Now test if MersTest is a Prime ***

                        MersPrime = 0
                        MersDiv = 3

                        DO
                                IF MersTest > 2147483647 THEN
                                     
                                        PRINT
                                        PRINT
                                        PRINT "Routine aborted, MOD can't cope with big numbers !!!"
                                        MersPrime = 1
                                        Count = UserNum
                                        EXIT DO
                                END IF

                                IF MersTest MOD MersDiv = 0 THEN MersPrime = 1
                                MersDiv = MersDiv + 2
                                IF MersDiv > SQR(MersTest) THEN EXIT DO

                        LOOP UNTIL MersPrime = 1

                        IF MersPrime = 0 THEN
                                Perf = (2 ^ (TestNum - 1)) * MersTest
                                IF Perf > UserNum THEN EXIT DO
                                PRINT Perf;
                                Count = Count + 1
                        END IF
                END IF

                IF CSRLIN > 19 THEN
                        Continue
                        CLS
                        PRINT
                END IF


        LOOP UNTIL Perf >= UserNum

        PRINT
        PRINT
        PRINT "There are"; Count; "Perfect numbers smaller or equal to"; UserNum
END IF

IF UserIn$ = "C" THEN   '*** Number is part of the series? ***
   
        TestNum = 3
        Count = 2

        DO
                '*** First of all find the Prime Numbers ***
             
                Prime = 0
                Divisor = 3
                TestNum = TestNum + 2
 
                DO
                        IF TestNum MOD Divisor = 0 THEN Prime = 1
                        Divisor = Divisor + 2
                        IF Divisor > SQR(TestNum) THEN EXIT DO

                LOOP UNTIL Prime = 1
             
                '*** Now we've got a Prime, calculate the Mersenne Prime ***
             
                IF Prime = 0 THEN
                     
                        MersTest = (2 ^ TestNum) - 1

                        '*** Now test if MersTest is a Prime ***

                        MersPrime = 0
                        MersDiv = 3

                        DO
                                IF MersTest > 2147483647 THEN
                                     
                                        PRINT
                                        PRINT
                                        PRINT "Routine aborted, MOD can't cope with big numbers !!!"
                                        MersPrime = 1
                                        Count = UserNum
                                        EXIT DO
                                END IF

                                IF MersTest MOD MersDiv = 0 THEN MersPrime = 1
                                MersDiv = MersDiv + 2
                                IF MersDiv > SQR(MersTest) THEN EXIT DO

                        LOOP UNTIL MersPrime = 1

                        IF MersPrime = 0 THEN
                               
                                Perf = (2 ^ (TestNum - 1)) * MersTest
                                Count = Count + 1
                                IF Perf >= UserNum THEN EXIT DO
                                IF Perf < UserNum THEN OldNum = Perf
                        END IF
                      
                END IF

        LOOP UNTIL MersPrime = 0 AND Perf >= UserNum

        IF Perf = UserNum THEN
            
                PRINT UserNum; "is a Perfect number"
                PRINT
                PRINT "It is"; Count; "in the series"
        ELSE
                PRINT UserNum; "is not a Perfect number"
                PRINT
                PRINT "The next smallest number is"; OldNum; "the next Perfect number is"; Perf
        END IF
END IF

END SUB

SUB Primes

'*** Prime Numbers ***

DIM TestNum AS LONG     'TestNum the number being tested
DIM Prime AS INTEGER    'Switch to indicate a prime during testing
DIM Divisor AS LONG     'Holds divisors

Divisor = 2
Count = 2

CLS

PRINT
PRINT "PRIME NUMBERS"
PRINT
PRINT "Prime numbers are those that are only divisible by themselves or 1"
PRINT
PRINT "The program can calculate the primes up to 1 million in around 90 seconds"
PRINT

IF UserIn$ = "A" THEN   '*** First n of the series ***
       
        PRINT "Here are the first"; UserNum; "Prime numbers."
        PRINT

        PRINT 2; 3;     '*** I can't find a way of calculating these ***

        TestNum = 3
        Count = 2

        DO
                Prime = 0
                Divisor = 3
                TestNum = TestNum + 2
    
                DO
                        IF TestNum MOD Divisor = 0 THEN Prime = 1
                        Divisor = Divisor + 2
                        IF Divisor > SQR(TestNum) THEN EXIT DO

                LOOP UNTIL Prime = 1

                IF Prime = 0 THEN
                        PRINT TestNum;
                        Count = Count + 1
                END IF

                IF CSRLIN > 19 THEN
                        Continue
                        CLS
                        PRINT
                END IF

        LOOP UNTIL Count = UserNum
END IF

IF UserIn$ = "B" THEN   '*** Prime numbers up to and including a number ***
      
        PRINT "Here are the Prime numbers up to or equal to"; UserNum
        PRINT

        PRINT 2; 3;     '*** I can't find a way of calculating these ***

        TestNum = 3
        Count = 2

        DO
                Prime = 0
                Divisor = 3
                TestNum = TestNum + 2
   
                DO
                        IF TestNum MOD Divisor = 0 THEN Prime = 1
                        Divisor = Divisor + 2
                        IF Divisor > SQR(TestNum) THEN EXIT DO

                LOOP UNTIL Prime = 1

                IF Prime = 0 THEN
                        IF TestNum > UserNum THEN EXIT DO
                        PRINT TestNum;
                        Count = Count + 1
                END IF

                IF CSRLIN > 19 THEN
                        Continue
                        CLS
                        PRINT
                END IF

        LOOP UNTIL TestNum >= UserNum

        PRINT
        PRINT
        PRINT "There are"; Count; "Prime numbers smaller or equal to"; UserNum
END IF

IF UserIn$ = "C" THEN   '*** Number is part of the series? ***
     
        TestNum = 3
        Count = 2

        DO
                Prime = 0
                Divisor = 3
                TestNum = TestNum + 2

                DO
                        IF TestNum MOD Divisor = 0 THEN Prime = 1
                        Divisor = Divisor + 2
                        IF Divisor > SQR(TestNum) THEN EXIT DO

                LOOP UNTIL Prime = 1

                IF Prime = 0 THEN
                        Count = Count + 1
                        IF TestNum >= UserNum THEN EXIT DO
                        IF TestNum < UserNum THEN OldNum = TestNum
                        
                END IF

        LOOP UNTIL Prime = 0 AND TestNum >= UserNum

        IF TestNum = UserNum THEN
              
                PRINT UserNum; "is a Prime number"
                PRINT
                PRINT "It is"; Count; "in the series"
        ELSE
                PRINT UserNum; "is not a Prime number"
                PRINT
                PRINT "The next smallest number is"; OldNum; "the next Prime number is"; TestNum
        END IF
END IF

END SUB

SUB QSort (SortArray() AS LONG, Low AS INTEGER, High AS DOUBLE)

DIM Lower AS INTEGER
DIM Higher AS INTEGER
DIM RandIndex AS INTEGER
DIM Partition AS DOUBLE


'QuickSort works by picking a random "pivot" element in SortArray, then
'moving every element that is bigger to one side of the pivot, and every
'element that is smaller to the other side. QuickSort is then called
'recursively with the two subdivisions created by the pivot. Once the
'number of elements in a subdivision reaches two, the recursive calls end
'and the array is sorted.

IF Low < High THEN

        ' *** Only two elements in this subdivision ***
        ' *** Swap them if they are out of order, then end recursive calls: ***

        IF High - Low = 1 THEN
                IF SortArray(Low) > SortArray(High) THEN
                        SWAP SortArray(Low), SortArray(High)
                END IF
        ELSE

                '*** Pick a pivot element at random, then move it to the end ***

                RandIndex = INT(RND * (High - Low + 1)) + Low
                SWAP SortArray(High), SortArray(RandIndex)
                Partition = SortArray(High)
                DO

                        '*** Move in from both sides towards the pivot element ***

                        Lower = Low
                        Higher = High
                        DO WHILE (Lower < Higher) AND (SortArray(Lower) <= Partition)
                                Lower = Lower + 1
                        LOOP

                        DO WHILE (Higher > Lower) AND (SortArray(Higher) >= Partition)
                                Higher = Higher - 1
                        LOOP

                        '*** If pivot element not reached, it means that ***
                        '*** two elements on either side are out of order, ***
                        '*** so swap them ***
               
                        IF Lower < Higher THEN
                                SWAP SortArray(Lower), SortArray(Higher)
                        END IF

                LOOP WHILE Lower < Higher

                '*** Move the pivot element back to its proper place in the array ***

                SWAP SortArray(Lower), SortArray(High)

                '*** Recursively call the SortArray sub ***
                '*** Pass the smaller subdivision first to use less stack space ***

                IF (Lower - Low) < (High - Lower) THEN
                        QSort SortArray(), Low, Lower - 1
                        QSort SortArray(), Lower + 1, High
                ELSE
                        QSort SortArray(), Lower + 1, High
                        QSort SortArray(), Low, Lower - 1
                END IF
        END IF
END IF

END SUB

SUB Square

'*** Square numbers ***

DIM SqrNum AS LONG      'Square number

CLS

PRINT
PRINT "SQUARE NUMBERS"
PRINT
PRINT "Square numbers are those whose square roots are an interger "
PRINT

IF UserIn$ = "A" THEN   '*** First n of the series ***
       
        PRINT "These are the first"; UserNum; "square numbers."
        PRINT

        SqrNum = 0

        FOR Count = 1 TO UserNum
       
                SqrNum = SqrNum + 1
                PRINT SqrNum * SqrNum;

                IF CSRLIN > 19 THEN
                        Continue
                        CLS
                        PRINT
                END IF
       
        NEXT Count
END IF

IF UserIn$ = "B" THEN   '*** Square numbers up to a number ***
      
        PRINT "These are the Square Numbers smaller or equal to"; UserNum
        PRINT

        SqrNum = 0
        Count = 0

        DO
                SqrNum = SqrNum + 1
                IF SqrNum * SqrNum > UserNum THEN EXIT DO
                PRINT SqrNum * SqrNum;
                Count = Count + 1

                IF CSRLIN > 19 THEN
                        Continue
                        CLS
                        PRINT
                END IF
      
        LOOP UNTIL SqrNum * SqrNum >= UserNum

        PRINT
        PRINT
        PRINT "There are"; Count; "Square Numbers smaller or equal to"; UserNum
END IF

IF UserIn$ = "C" THEN   '*** Number is a square number? ***
     
        SqrNum = 0
        Count = 0

        DO
                OldNum = SqrNum * SqrNum
                SqrNum = SqrNum + 1
                IF SqrNum * SqrNum > UserNum THEN EXIT DO
                Count = Count + 1

        LOOP UNTIL SqrNum * SqrNum >= UserNum

        IF SqrNum * SqrNum = UserNum THEN
             
                PRINT UserNum; "is a square number"
                PRINT
                PRINT "It is"; Count; "in the series"
        ELSE
                PRINT UserNum; "is not a square number"
                PRINT
                PRINT "The next smallest number is"; OldNum; "the next square number is"; SqrNum * SqrNum
        END IF
END IF

END SUB

SUB Triang

'*** Triangular numbers ***

DIM Tri AS LONG         'The triangular number

CLS

PRINT
PRINT "TRINGULAR NUMBERS"
PRINT
PRINT "Triangular numbers are a type of arithmetic progression"
PRINT

IF UserIn$ = "A" THEN   '*** First n of the series ***

        PRINT "These are the first"; UserNum; "triangular numbers."
        PRINT

        Tri = 0
   
        FOR Count = 1 TO UserNum

                Tri = Tri + Count
                PRINT Tri;

                IF CSRLIN > 19 THEN
                        Continue
                        CLS
                        PRINT
                END IF

        NEXT Count
END IF

IF UserIn$ = "B" THEN   '*** Triangular numbers smaller or equal to UserNum ***

        PRINT "These are triangular numbers smaller or equal to"; UserNum
        PRINT

        Tri = 0
        Count = 1
  
        DO
                Tri = Tri + Count
                IF Tri > UserNum THEN EXIT DO
                PRINT Tri;
                Count = Count + 1

                IF CSRLIN > 19 THEN
                        Continue
                        CLS
                        PRINT
                END IF
       
        LOOP UNTIL Tri >= UserNum

        PRINT
        PRINT
        PRINT "There are"; Count - 1; "triangular numbers smaller or equal to"; UserNum
END IF

IF UserIn$ = "C" THEN   '*** UserNum is a triangular number? ***

        Tri = 0
        Count = 1
 
        DO
                OldNum = Tri
                Tri = Tri + Count
                IF Tri > UserNum THEN EXIT DO
                Count = Count + 1

        LOOP UNTIL Tri >= UserNum
       
        IF Tri = UserNum THEN
           
                PRINT UserNum; "is a triangular number"
                PRINT
                PRINT "It is"; Count - 1; "in the series"
        ELSE
                PRINT UserNum; "is not a triangular number"
                PRINT
                PRINT "The next smallest number is"; OldNum; "the next triangular number is"; Tri
        END IF
END IF

END SUB

SUB Vampire

DIM VampAry(10000) AS LONG      'Aray to hold Vampire numbers for sorting
DIM VampTest AS DOUBLE          'Number to test
DIM VampStr AS STRING           'String to hold VampTest
DIM VampCnt AS DOUBLE           'Number of vampire numbers produced
DIM Div1 AS LONG                'First divisor
DIM Div2 AS LONG                'Second divisor
DIM VampFnd AS INTEGER          'Vampire number found
DIM DivStr AS STRING            'String to hold Div1 and Div2
DIM Div1Str AS STRING           'String to hold Div1
DIM Div2Str AS STRING           'String to hold Div2
DIM DivChar AS STRING * 1       'String to hold individual characters from DivStr$
DIM DivFnd AS INTEGER           'Character position of DivChar$ in VampStr$
DIM Div1Strt AS LONG            'Start number for Div1
DIM Div2Strt AS LONG            'Start number for Div2
DIM UniqVamp AS INTEGER         'Unique Vampire numbers produced
DIM LastVamp AS LONG            'The last found Vampire number

CLS
PRINT
PRINT "VAMPIRE NUMBERS"
PRINT
PRINT "Vampire numbers are numbers with an even number of digits. When mixed and"
PRINT "each pair of numbers when multiplied together give the vampire number."
PRINT
PRINT "The results are only accurate until the next step in the number of digits"
PRINT "in the Vampire number is reached."
PRINT

IF UserIn$ = "A" THEN   '*** First n of a series ***
      
        PRINT "These are the first"; UserNum; "CALCULATED Vampire numbers."
        PRINT

        Div1 = 33
        VampFnd = 0
        Div1Strt = 33
        Div2Strt = 10
        VampCnt = 0
        UniqVamp = 0
       
        DO
                '*** Div1 does not have to start from 10, 100, 1000 etc. ***
                '*** It needs to start at 33, 333, 3333 etc. ***

                '*** Ensure that Div1 and Div2 are of equal length ***
                '*** If Div1 = 333, Div2 = 100, if Div1 = 3333, Div2 = 1000 etc. ***
               
                IF LEN(LTRIM$(STR$(Div1))) > LEN(LTRIM$(STR$(Div1Strt))) THEN
                        Div1Strt = (Div1Strt * 10) + 3
                        Div1 = Div1Strt
                        Div2Strt = Div2Strt * 10
                END IF

                Div2 = Div2Strt
               
                DO
                        VampFnd = 0
                        VampTest = Div1 * Div2

                        '*** Test VampTest for being a Vampire Number ***
                       
                        VampStr$ = LTRIM$(STR$(VampTest))
                        IF Div1 MOD 10 = 0 AND Div2 MOD 10 = 0 THEN VampFnd = 1
                        IF LEN(VampStr$) MOD 2 <> 0 THEN VampFnd = 1

                        DivStr$ = LTRIM$(STR$(Div1)) + LTRIM$(STR$(Div2))

                        '*** Test to see if the Div numbers are part of VampTest ***

                        FOR Count = 1 TO LEN(DivStr$)

                                DivChar$ = MID$(DivStr$, Count, 1)
                                DivFnd = INSTR(VampStr$, DivChar$)
                                IF DivFnd > 0 THEN
                                        MID$(VampStr$, DivFnd, 1) = "X"
                                ELSE
                                        VampFnd = 1
                                END IF
                        NEXT Count
                        
                        '*** If VampFnd = 0 then VampTest is a Vampire Number *** 
                       
                        IF VampFnd = 0 THEN
                               
                                VampCnt = VampCnt + 1
                                VampAry(VampCnt) = VampTest
                        END IF

                        Div2 = Div2 + 1

                LOOP UNTIL Div2 > Div1

                        Div1 = Div1 + 1
               
        LOOP UNTIL VampCnt >= UserNum
       
        '*** The Vampire numbers produced need to be sorted ***
        '*** and the duplicates discarded ***

        QSort VampAry(), 1, VampCnt
        FOR Count = 1 TO VampCnt
                IF VampAry(Count + 1) <> VampAry(Count) THEN
                        PRINT VampAry(Count);
                        UniqVamp = UniqVamp + 1
                END IF
               
                IF CSRLIN > 19 THEN
                        Continue
                        CLS
                        PRINT
                END IF
       
        NEXT Count

        PRINT
        PRINT
        PRINT "The sequence contains"; UniqVamp; "Vampire numbers."
        PRINT "There were"; VampCnt - UniqVamp; "discarded duplicates."
END IF

IF UserIn$ = "B" THEN   '*** Calculated numbers up to and including UserNum ***
     
        PRINT "Here are the CALCULATED Vampire numbers up to or equal to"; UserNum
        PRINT

        Div1 = 33
        VampFnd = 0
        Div1Strt = 33
        Div2Strt = 10
        UniqVamp = 0
        VampCnt = 0
      
        DO
                '*** Div1 does not have to start from 10, 100, 1000 etc. ***
                '*** It needs to start at 33, 333, 3333 etc. ***

                '*** Ensure that Div1 and Div2 are of equal length ***
                '*** If Div1 = 333, Div2 = 100, if Div1 = 3333, Div2 = 1000 etc. ***
              
                IF LEN(LTRIM$(STR$(Div1))) > LEN(LTRIM$(STR$(Div1Strt))) THEN
                        Div1Strt = (Div1Strt * 10) + 3
                        Div1 = Div1Strt
                        Div2Strt = Div2Strt * 10
                END IF

                Div2 = Div2Strt
              
                DO
                        VampFnd = 0
                        VampTest = Div1 * Div2

                        '*** Test VampTest for being a Vampire Number ***
                      
                        VampStr$ = LTRIM$(STR$(VampTest))
                        IF Div1 MOD 10 = 0 AND Div2 MOD 10 = 0 THEN VampFnd = 1
                        IF LEN(VampStr$) MOD 2 <> 0 THEN VampFnd = 1

                        DivStr$ = LTRIM$(STR$(Div1)) + LTRIM$(STR$(Div2))

                        '*** Test to see if the Div numbers are part of VampTest ***

                        FOR Count = 1 TO LEN(DivStr$)

                                DivChar$ = MID$(DivStr$, Count, 1)
                                DivFnd = INSTR(VampStr$, DivChar$)
                                IF DivFnd > 0 THEN
                                        MID$(VampStr$, DivFnd, 1) = "X"
                                ELSE
                                        VampFnd = 1
                                END IF
                        NEXT Count
                       
                        '*** If VampFnd = 0 then VampTest is a Vampire Number ***
                      
                        IF VampFnd = 0 THEN
                              
                                VampCnt = VampCnt + 1
                                VampAry(VampCnt) = VampTest
                        END IF

                        Div2 = Div2 + 1

                LOOP UNTIL Div2 > Div1

                        Div1 = Div1 + 1
              
        LOOP UNTIL VampTest >= UserNum
      
        '*** The Vampire numbers produced need to be sorted ***
        '*** and the duplicates discarded ***

        QSort VampAry(), 1, VampCnt
        FOR Count = 1 TO VampCnt
                IF VampAry(Count + 1) <> VampAry(Count) THEN
                        PRINT VampAry(Count);
                        UniqVamp = UniqVamp + 1
                END IF

                IF CSRLIN > 19 THEN
                        Continue
                        CLS
                        PRINT
                END IF

        NEXT Count

        PRINT
        PRINT
        PRINT "There are"; UniqVamp; "CALCULATED Vampire numbers smaller or equal to"; UserNum
        PRINT "There were"; VampCnt - UniqVamp; "discarded duplicates."
END IF

IF UserIn$ = "C" THEN   '*** Number is part of the series? ***
    
        Div1 = 33
        VampFnd = 0
        Div1Strt = 33
        Div2Strt = 10
     
        DO
                '*** Div1 does not have to start from 10, 100, 1000 etc. ***
                '*** It needs to start at 33, 333, 3333 etc. ***

                '*** Ensure that Div1 and Div2 are of equal length ***
                '*** If Div1 = 333, Div2 = 100, if Div1 = 3333, Div2 = 1000 etc. ***
             
                IF LEN(LTRIM$(STR$(Div1))) > LEN(LTRIM$(STR$(Div1Strt))) THEN
                        Div1Strt = (Div1Strt * 10) + 3
                        Div1 = Div1Strt
                        Div2Strt = Div2Strt * 10
                END IF

                Div2 = Div2Strt
             
                DO
                        VampFnd = 0
                        VampTest = Div1 * Div2

                        '*** Test VampTest for being a Vampire Number ***
                     
                        VampStr$ = LTRIM$(STR$(VampTest))
                        IF Div1 MOD 10 = 0 AND Div2 MOD 10 = 0 THEN VampFnd = 1
                        IF LEN(VampStr$) MOD 2 <> 0 THEN VampFnd = 1

                        DivStr$ = LTRIM$(STR$(Div1)) + LTRIM$(STR$(Div2))

                        '*** Test to see if the Div numbers are part of VampTest ***

                        FOR Count = 1 TO LEN(DivStr$)

                                DivChar$ = MID$(DivStr$, Count, 1)
                                DivFnd = INSTR(VampStr$, DivChar$)
                                IF DivFnd > 0 THEN
                                        MID$(VampStr$, DivFnd, 1) = "X"
                                ELSE
                                        VampFnd = 1
                                END IF
                        NEXT Count
                      
                        '*** If VampFnd = 0 then VampTest is a Vampire Number ***
                     
                        IF VampFnd = 0 THEN
                             
                                VampCnt = VampCnt + 1
                                VampAry(VampCnt) = VampTest
                                LastVamp = VampTest

                        END IF

                        Div2 = Div2 + 1

                LOOP UNTIL Div2 > Div1

                        Div1 = Div1 + 1
             
        LOOP UNTIL LastVamp > UserNum
     
        '*** The Vampire numbers produced need to be sorted ***
        '*** and the duplicates discarded ***

        QSort VampAry(), 1, VampCnt
       
        Count = 0

        DO
                Count = Count + 1
                IF VampAry(Count + 1) <> VampAry(Count) THEN UniqVamp = UniqVamp + 1
       
        LOOP UNTIL VampAry(Count) >= UserNum

        IF VampAry(Count) = UserNum THEN
       
                PRINT VampAry(Count); "is a Vampire Number,"
                PRINT
                PRINT "it is"; Count - (UniqVamp - Count); "in the CALCULATED series"
        ELSE
                PRINT UserNum; "is not a CALCULATED Vampire number,"
                PRINT
                IF Count > 1 THEN
                        PRINT "the next smallest CALCULATED number is"; VampAry(Count - 1);
                        PRINT
                END IF
                PRINT "the next largest CALCULATED Vampire number is"; VampAry(Count)
        END IF
END IF

END SUB

